TM/urls.py
# flake8: noqa

from django.urls import path
from . import views

app_name = 'TM'

urlpatterns = [
    # Tree visualization
    path("<int:vocab_id>/tree_data/", views.tree_data, name="tree_data"),
    path("tree_modify/", views.tree_modify, name="tree_modify"),
    path("tree/", views.tree, name="tree"),

    # Vocabulary administration
    path("vocab_create/", views.create_new_vocab, name="vocab_create"),
    path("vocab_list/", views.vocab_list, name="vocab_list"),
    path("<int:vocab_id>/vocab_detail/", views.vocab_detail, name="vocab_detail"),
    path("<int:vocab_id>/vocab_edit/", views.vocab_edit, name="vocab_edit"),
    path("<int:vocab_id>/vocab_delete/", views.vocab_delete, name="vocab_delete"),
    path("help/", views.help, name="help"),
    ]

ThesaurusManager/urls.py
from django.contrib import admin
from django.contrib.auth import views as auth_views
from django.urls import include, re_path


urlpatterns = [
    re_path(r'^', include('TM.urls')),
    re_path(r'^admin/', admin.site.urls),
    re_path(r'^accounts/login/$', auth_views.LoginView.as_view(), name='login'),
    re_path(r'^accounts/logout/$', auth_views.LogoutView.as_view(), name='logout'),
]

TM/models.py
from __future__ import unicode_literals

from django.db import models
from django.contrib.auth.models import User


class Provider(models.Model):
    id = models.IntegerField(primary_key=True)
    name = models.TextField()
    url = models.TextField(blank=True, null=True)
    description = models.TextField(blank=True, null=True)

    class Meta:
        managed = True
        db_table = "provider"

    def __str__(self):
        url = " (" + self.url + ")" if self.url else ""
        description = ", " + self.description if self.description else ""
        return self.name + url + description


class Vocabulary(models.Model):
    PRIVATE = "private"
    PUBLIC_VISIBLE = "public_visible"
    MODIFIABLE_BY_OTHERS = "modifiable_by_others"
    ACCESS_LEVEL_CHOICES = (
        (PRIVATE, "privat"),
        (PUBLIC_VISIBLE, "öffentlich sichtbar"),
        (MODIFIABLE_BY_OTHERS, "durch andere Nutzer veränderbar")
    )

    id = models.IntegerField(primary_key=True)
    provider = models.ForeignKey(Provider, on_delete=models.PROTECT)
    status = models.TextField(blank=True, null=True)
    domain = models.TextField(blank=True, null=True)
    name = models.TextField()
    version = models.TextField(blank=True, null=True)
    description = models.TextField(blank=True, null=True)
    base_url = models.TextField(blank=True, null=True)
    owner = models.ForeignKey(User, on_delete=models.SET_NULL, null=True)
    access_level = models.CharField(
        max_length=20, choices=ACCESS_LEVEL_CHOICES)

    class Meta:
        managed = True
        db_table = "vocabulary"


class Concept(models.Model):
    id = models.IntegerField(primary_key=True)
    identifier = models.TextField()
    vocab = models.ForeignKey(Vocabulary, on_delete=models.CASCADE)

    class Meta:
        managed = True
        db_table = "concept"

    def __str__(self):
        name = self.__class__.__name__
        params = dict(id=self.id, vocab=self.vocab_id,
                      identifier=self.identifier)
        return '%s(%s)' % (
            name, ', '.join('%s=%s' % p for p in params.items()))


class Definition(models.Model):
    id = models.IntegerField(primary_key=True)
    identifier = models.TextField(blank=True, null=True)
    concept = models.ForeignKey(Concept, on_delete=models.CASCADE)
    lang = models.TextField()
    text = models.TextField()

    class Meta:
        managed = True
        db_table = "definition"


class ExternalReference(models.Model):
    id = models.IntegerField(primary_key=True)
    concept = models.ForeignKey(Concept, on_delete=models.CASCADE)
    target_url = models.TextField()

    class Meta:
        managed = True
        db_table = "external_reference"


class Label(models.Model):
    id = models.IntegerField(primary_key=True)
    identifier = models.TextField(blank=True, null=True)
    concept = models.ForeignKey(Concept, on_delete=models.CASCADE)
    lang = models.TextField()
    text = models.TextField()
    is_preferred = models.TextField()

    class Meta:
        managed = True
        db_table = "label"


class Reference(models.Model):
    id = models.IntegerField(primary_key=True)
    concept = models.ForeignKey(Concept, on_delete=models.CASCADE)
    target_concept = models.ForeignKey(
        Concept, related_name="reference_target_concept",
        on_delete=models.CASCADE)

    class Meta:
        managed = True
        db_table = "reference"


class Relation(models.Model):
    id = models.IntegerField(primary_key=True)
    identifier = models.TextField(blank=True, null=True)
    this_concept = models.ForeignKey(
        Concept, on_delete=models.CASCADE, related_name="subj")
    other_concept = models.ForeignKey(
        Concept, on_delete=models.CASCADE, related_name="obj")
    type = models.TextField()

    class Meta:
        managed = True
        db_table = "relation"


class SortOrderHit(models.Model):
    id = models.IntegerField(primary_key=True)
    concept = models.ForeignKey(Concept, on_delete=models.CASCADE)
    position_hit = models.IntegerField()

    class Meta:
        managed = True
        db_table = "sort_order_hit"


class Variant(models.Model):
    id = models.IntegerField(primary_key=True)
    label = models.ForeignKey(Label, on_delete=models.CASCADE)
    text = models.TextField()
    comment = models.TextField(blank=True, null=True)

    class Meta:
        managed = True
        db_table = "variant"

TM/forms.py
from django import forms
from .models import Provider
from .models import Vocabulary


class VocabForm(forms.Form):
    name = forms.CharField(label="Name", required=True)
    version = forms.DecimalField(
        label="Versionsnummer", min_value=0.0, initial=1.0, required=True)
    domain = forms.CharField(label="Bereich/Thema", required=False)
    description = forms.CharField(
        label="Beschreibung", widget=forms.Textarea, required=False)
    provider = forms.ModelChoiceField(queryset=Provider.objects.all())
    access_level = forms.ChoiceField(
        label="Zugriffsmodus", choices=Vocabulary.ACCESS_LEVEL_CHOICES,
        required=True)


class VocabCreateForm(VocabForm):
    GERMAN = 'de'
    FRENCH = 'fr'
    ENGLISH = 'en'
    ITALIAN = 'it'
    LANGUAGE_CHOICES = (
        (GERMAN, 'DE'),
        (FRENCH, 'FR'),
        (ENGLISH, 'EN'),
        (ITALIAN, 'IT'),
    )
    root_name = forms.CharField(label="Name des Wurzelknotens", required=True)
    lang = forms.ChoiceField(
        label="Sprache", choices=LANGUAGE_CHOICES, required=True)


class VocabEditForm(VocabForm):
    INTERN = 'intern'
    EXTERN = 'extern'
    STATUS_CHOICES = (
        (INTERN, 'intern'),
        (EXTERN, 'extern'),
    )
    status = forms.ChoiceField(
        label="Status", choices=STATUS_CHOICES, required=True)
    base_url = forms.CharField(label="Base URL", required=False)

TM/views.py
from django.conf import settings
from django.shortcuts import render
from django.db.models import Q
from django.db.models import Max
from django.http import HttpResponse
from django.http import HttpResponseRedirect
from django.urls import reverse
from django.db import transaction
from django.core.exceptions import ObjectDoesNotExist
from django.contrib.auth.decorators import login_required
import json

from .models import Vocabulary, Concept, Label, Definition, Reference, \
    ExternalReference
from .DataTransformerCached import writeDictFromRelationalModel
from .TreeUpdaterCachedBulk import update_tree
from .forms import VocabCreateForm, VocabEditForm, VocabForm
from .jsonValidator import SCHEMA


@transaction.atomic
def tree_data(request, vocab_id):
    """View delivering the tree structure as JSON data"""
    try:
        vocab = Vocabulary.objects.get(pk=vocab_id)
    except ObjectDoesNotExist:
        return HttpResponse(
            json.dumps(dict(tree=None, vocab_id=vocab_id)), "application/json")

    if (vocab.access_level in (
            Vocabulary.PUBLIC_VISIBLE, Vocabulary.MODIFIABLE_BY_OTHERS)
            or (request.user.is_authenticated
                and vocab.owner == request.user)):
        tree = writeDictFromRelationalModel(vocab.id)
        modification_allowed = (
            request.user.is_authenticated
            and (vocab.access_level == Vocabulary.MODIFIABLE_BY_OTHERS
                 or vocab.owner == request.user))
        return HttpResponse(json.dumps(dict(
            tree=tree,
            vocab_id=vocab_id,
            modification_allowed=modification_allowed,
            authenticated=request.user.is_authenticated
        )), "application/json")
    else:
        return HttpResponse(
            json.dumps(dict(tree=None, vocab_id=vocab_id)), "application/json")


@transaction.atomic
def tree(request):
    """Main view for tree selection and graphical visualization"""

    query_filter = Q(access_level__in=(
        Vocabulary.PUBLIC_VISIBLE, Vocabulary.MODIFIABLE_BY_OTHERS))
    if request.user.is_authenticated:
        query_filter = query_filter | Q(owner=request.user)

    vocabs = Vocabulary.objects \
        .filter(query_filter) \
        .select_related("provider") \
        .order_by("name")
    vocab_selection = [dict(
        id=vocab.id,
        name=vocab.name,
        version=vocab.version,
        provider=vocab.provider.name,
        modifiable=(
            request.user.is_authenticated
            and (vocab.access_level == Vocabulary.MODIFIABLE_BY_OTHERS
                 or vocab.owner == request.user)),
        owning_state=("own" if vocab.owner == request.user else "other"),
        tree_url=reverse("TM:tree_data", args=(vocab.id,))
    ) for vocab in vocabs]

    # Find available languages
    languages = {"de", "en", "fr", "it"} \
        | {lang.strip() for lang in
           Label.objects.values_list("lang", flat=True).distinct()} \
        | {lang.strip() for lang in
           Definition.objects.values_list("lang", flat=True).distinct()}

    return render(request, "TM/tree.html", dict(
        vocab_selection=json.dumps(vocab_selection),
        languages=json.dumps(sorted(languages)),
        json_schema=json.dumps(SCHEMA)))


@login_required
@transaction.atomic
def tree_modify(request):
    """
    View for modifying the tree
    """
    if request.method == "POST":
        if "tree" in request.POST and "vocab_id" in request.POST:
            try:
                vocab = Vocabulary.objects.get(pk=request.POST.get("vocab_id"))
            except ObjectDoesNotExist:
                return HttpResponse(
                    json.dumps(dict(success=False)), "application/json")

            if (Vocabulary.MODIFIABLE_BY_OTHERS == vocab.access_level
                    or vocab.owner == request.user):
                try:
                    update_tree(json.loads(request.POST.get("tree")), vocab.id)
                    return HttpResponse(
                        json.dumps(dict(success=True)), "application/json")
                except Exception as e:
                    resp = dict(success=False)
                    if settings.DEBUG:
                        resp["error"] = str(e)
                    return HttpResponse(json.dumps(resp), "application/json")

    return HttpResponse(json.dumps(dict(success=False)), "application/json")


@login_required
@transaction.atomic
def create_new_vocab(request):
    """View for creating new trees"""
    if request.method == "POST" and request.POST.get("name", None):
        if request.POST.get("tree", None):
            # Copy of an existing tree
            form = VocabForm(request.POST)
        else:
            # New tree
            form = VocabCreateForm(request.POST)

        if form.is_valid():
            # New vocabulary
            max_vocab_id = Vocabulary.objects.aggregate(
                Max("id"))["id__max"] or 0
            vocab = Vocabulary.objects.create(
                id=(max_vocab_id + 1),
                provider=form.cleaned_data["provider"],
                status="intern",
                domain=form.cleaned_data["domain"],
                name=form.cleaned_data["name"],
                version=form.cleaned_data["version"],
                description=form.cleaned_data["description"],
                base_url=None,
                owner=request.user,
                access_level=form.cleaned_data["access_level"]
            )
            # New concept
            max_concept_id = Concept.objects.aggregate(
                Max("id"))["id__max"] or 0
            concept = Concept.objects.create(
                id=(max_concept_id + 1), identifier="--", vocab=vocab)

            if request.POST.get("tree", None):
                # Copy of an existing tree
                json_root_node = json.loads(request.POST.get("tree"))
                json_root_node["id"] = concept.id
                update_tree(json_root_node, vocab.id)
            else:
                # New label
                max_label_id = Label.objects.aggregate(
                    Max("id"))["id__max"] or 0
                Label.objects.create(
                    id=(max_label_id + 1),
                    identifier=None,
                    concept=concept,
                    lang=form.cleaned_data["lang"],
                    text=form.cleaned_data["root_name"],
                    is_preferred="true")

            return HttpResponseRedirect(
                reverse("TM:vocab_list"))
    else:
        if request.method == "POST" and request.POST.get("tree", None):
            # Copy of an existing tree
            form = VocabForm()
        else:
            # New tree
            form = VocabCreateForm()

    context = dict(form=form)

    if request.method == "POST" and request.POST.get("tree", None):
        context["tree"] = request.POST.get("tree")

    return render(request, "TM/vocab_create_form.html", context)


@login_required
@transaction.atomic
def vocab_list(request):
    """View for showing vocabulary list"""
    vocabs = Vocabulary.objects \
                       .filter(owner=request.user) \
                       .select_related("provider") \
                       .order_by("name")
    return render(request, "TM/vocab_list.html", dict(
        vocabs=[__get_vocab_attribute_as_dict(vocab) for vocab in vocabs],
        json_schema=json.dumps(SCHEMA)
    ))


@login_required
@transaction.atomic
def vocab_detail(request, vocab_id):
    """View for the details of a vocabulary"""
    try:
        vocab = Vocabulary.objects.select_related("provider").get(pk=vocab_id)
        if vocab.owner == request.user:
            vocab_dict = __get_vocab_attribute_as_dict(vocab)
            __calculate_statistics(vocab, vocab_dict)
            return render(
                request, "TM/vocab_detail.html", dict(vocab=vocab_dict))
    except ObjectDoesNotExist:
        pass
    return HttpResponseRedirect(reverse("TM:vocab_list",))


@login_required
@transaction.atomic
def vocab_edit(request, vocab_id):
    """View for editing a vocabulary"""
    try:
        vocab = Vocabulary.objects.select_related("provider").get(pk=vocab_id)
        if vocab.owner == request.user:
            if request.method == "POST":
                form = VocabEditForm(request.POST)
                if form.is_valid():
                    vocab.name = form.cleaned_data["name"]
                    vocab.version = form.cleaned_data["version"]
                    vocab.domain = form.cleaned_data["domain"]
                    vocab.description = form.cleaned_data["description"]
                    vocab.provider = form.cleaned_data["provider"]
                    vocab.status = form.cleaned_data["status"]
                    vocab.base_url = form.cleaned_data["base_url"]
                    vocab.access_level = form.cleaned_data["access_level"]
                    vocab.save()
                    return HttpResponseRedirect(
                        reverse("TM:vocab_detail", args=(vocab.id,)))
            else:
                form = VocabEditForm(
                    initial=__get_vocab_attribute_as_dict(vocab, True))
            return render(
                request, "TM/vocab_edit.html", dict(
                    vocab_id=vocab_id, form=form))
    except ObjectDoesNotExist:
        pass
    return HttpResponseRedirect(reverse("TM:vocab_list",))


@login_required
@transaction.atomic
def vocab_delete(request, vocab_id):
    """View for deleting a vocabulary"""
    try:
        vocab = Vocabulary.objects.get(pk=vocab_id)
        if vocab.owner == request.user:
            vocab.delete()
    except ObjectDoesNotExist:
        pass
    return HttpResponseRedirect(reverse("TM:vocab_list",))


def __get_vocab_attribute_as_dict(vocab, raw_choice_values=False):
    """
    Helper function for copying the attributes of a vocabulary in a dictionary
    """
    return dict(
        id=vocab.id,
        name=vocab.name,
        domain=vocab.domain,

TM/templates/TM/help_site.html
{% load static %}
<!DOCTYPE html>
<html>
<head>
	<link rel="stylesheet" type="text/css" href="{% static 'TM/css/stylesheet.css' %}" />
	<link rel="stylesheet" type="text/css" href="{% static 'TM/css/vocab_stylesheet.css' %}" />
	<script type="application/javascript" src="{% static '3rdparty/jquery/1.12.4/jquery.min.js' %}"></script>
</head>
<body>
	<h1>Anleitungen</h1>
	<div id="instructions">
		{% for filename, title in video_files %}
		<div>
			<h1>{{ title }}</h1>
			<video controls>
				{% with 'TM/media/'|add:filename as file_path %}
				<source src="{% static file_path %}" />
				{% endwith %}
			</video>
		</div>
		{% endfor %}
	</div>

	<script type="application/javascript">
		"use strict";

		$("div#instructions > div").each(function (index) {
			var video = $(this).find("video");
			$("<button>\u2193</button>").insertBefore(video)
			.on("click", function (event) {
				if (video.is(':visible')) {
					video.hide();
					video.get(0).pause();
					video.get(0).currentTime = 0;
					$(this).text("\u2193");
				} else {
					video.show();
					video.get(0).play();
					$(this).text("\u2191");
				}
			});
		});
	</script>
</body>
</html>

TM/templates/TM/vocab_base.html
{% load static %}
<!DOCTYPE html>
<html>
<head>
	<meta name="copyright" content="Rechtsquellenstiftung des Schweizerischen Juristenvereins SSRQ, histHub" />
	<link rel="stylesheet" type="text/css" href="{% static '3rdparty/jquery-ui/1.12.1/jquery-ui.min.css' %}" />
	<link rel="stylesheet" type="text/css" href="{% static 'TM/css/stylesheet.css' %}" />
	<link rel="stylesheet" type="text/css" href="{% static 'TM/css/vocab_stylesheet.css' %}" />
	<script type="application/javascript" src="{% static '3rdparty/jquery/1.12.4/jquery.min.js' %}"></script>
	<script type="application/javascript" src="{% static '3rdparty/jquery-ui/1.12.1/jquery-ui.min.js' %}"></script>
	<script type="application/javascript" src="{% static 'TM/scripts/helper_scripts.js' %}"></script>
</head>
<body>
	<div id="header">
		{% block header_controls %}{% endblock %}
		<div id="auth">
			{% if user.is_authenticated %}
			<form method="POST" action="{% url 'logout' %}">
				<input type="hidden" name="next" value="{% url 'TM:tree' %}" />
				{% csrf_token %}
				<p>{{ user.username }}</p>
				<input type="submit" class="button button-small button-salmon" value="Logout" />
			</form>
			{% else %}
			<p>Gast</p>
			<a href="{% url 'login' %}?next={% url 'TM:tree' %}" class="button button-small button-salmon">Login</a>
			{% endif %}
		</div>
	</div>
	<div id="title">
		{% block title %}{% endblock %}
	</div>
	{% block maincontent %}{% endblock %}
</body>
</html>

TM/templates/TM/vocab_create_form.html
{% extends "TM/vocab_base.html" %}
{% load static %}

{% block title %}
<h1>Neuen Thesaurus anlegen</h1>
{% endblock %}

{% block maincontent %}

<div id="create">
	<form action="{% url 'TM:vocab_create' %}" method="post" class="form">
		{% csrf_token %}
		<table>
			{{ form.as_table }}
		</table>
		<div id="buttons-below-row">
			<input type="submit" value="Speichern" class="button button-blue" />
			<a class="cancel button button-regular" href="{% url 'TM:vocab_list' %}">Abbrechen</a>
		</div>
	</form>
</div>

<script type="application/javascript">
	"use strict";

	$(function () {
		$("form").submit(function (event) {
			$("<input />").attr("type", "hidden")
						  .attr("name", "tree")
						  .attr("value", "{{ tree|escapejs }}")
						  .appendTo($(this));
			return true;
		});
	});
</script>

{% endblock %}

TM/templates/TM/vocab_detail.html
{% extends "TM/vocab_base.html" %}
{% load static %}

{% block header_controls %}
<a class="back button button-small button-regular" href="{% url 'TM:vocab_list' %}">&#8592;&nbsp;Thesauri-Liste</a>
{% endblock %}

{% block title %}
<h1>Detail</h1>
{% endblock %}

{% block maincontent %}

<div id="detail">
	<div id="vocab">
		<h3>
			Detailansicht
			<a class="button button-dark" href="{% url 'TM:vocab_edit' vocab.id %}">Bearbeiten</a>
			<a class="button button-salmon delete" href="javascript:void(0)">L&ouml;schen</a>
		</h3>
		<table>
			<tr><th><span>Name:</span></th><td><span>{{ vocab.name }}</span></td></tr>
			<tr><th><span>Version:</span></th><td><span>{{ vocab.version }}</span></td></tr>
			<tr><th><span>Bereich/Thema:</span></th><td><span>{{ vocab.domain }}</span></td></tr>
			<tr><th><span>Beschreibung:</span></th><td><span>{{ vocab.description }}</span></td></tr>
			<tr><th><span>Status:</span></th><td><span>{{ vocab.status }}</span></td></tr>
			<tr><th><span>Basis URL:</span></th><td><span>{{ vocab.base_url }}</span></td></tr>
			<tr><th><span>Provider:</span></th><td><span>{{ vocab.provider.name }}</span></td></tr>
			<tr><th><span>Zugriffsmodus:</span></th><td><span>{{ vocab.access_level }}</span></td></tr>
		</table>
	</div>
	<div id="statistics">
		<h3>Kennzahlen</h3>
		<table>
			<tr><th><span>Anzahl Konzepte</span></th><td><span>{{ vocab.number_of_concepts }}</span></td></tr>
			<tr><th><span>Anzahl Labels</span></th><td><span>{{ vocab.number_of_labels }}</span></td></tr>
			<tr><th><span>Anzahl Definitionen</span></th><td><span>{{ vocab.number_of_definitions }}</span></td></tr>
			<tr><th><span>Anzahl verlinkte Konzepte</span></th><td><span>{{ vocab.number_of_references }}</span></td></tr>
			<tr><th><span>Anzahl externe Verlinkungen</span></th><td><span>{{ vocab.number_of_external_references }}</span></td></tr>
		</table>
	</div>
</div>

<script type="application/javascript">
	"use strict";

	$("a.delete.button").on("click", function () {
		confirmDialog(
			"<p>Möchten Sie den Thesaurus</p><p class='thesaurusname'>{{ vocab.name }}</p><p>wirklich löschen?</p>",
			"Löschung",
			function () {
				window.location = "{% url 'TM:vocab_delete' vocab.id %}";
			}, undefined);
	});
</script>

{% endblock %}

TM/templates/TM/vocab_edit.html
{% extends "TM/vocab_base.html" %}
{% load static %}

{% block title %}
<h1>Thesaurus bearbeiten</h1>
{% endblock %}

{% block maincontent %}

<div id="edit">
	<form action="{% url 'TM:vocab_edit' vocab_id %}" method="post" class="form">
		{% csrf_token %}
		<table>
			{{ form.as_table }}
		</table>
		<div id="buttons-below-row">
			<input type="submit" value="Speichern" class="button button-blue" />
			<a class="cancel button button-regular" href="{% url 'TM:vocab_detail' vocab_id %}">Abbrechen</a>
		</div>
	</form>
</div>

{% endblock %}

TM/templates/TM/vocab_list.html
{% extends "TM/vocab_base.html" %}
{% load static %}

{% block title %}
<h1>Thesauri verwalten</h1>
<div id="controls">
	<a class="button button-dark" href="{% url 'TM:vocab_create' %}">Neuen Thesaurus anlegen</a>
</div>
{% endblock %}

{% block header_controls %}
<a class="button button-small button-regular" href="{% url 'TM:tree' %}">&#8592;&nbsp;Visualisierung</a>
{% endblock %}

{% block maincontent %}

	<div id="list">
		<h2>Gespeicherte Thesauri</h2>
		<table>
			<tr>
				<th><span>Name</span></th>
				<th><span>Version</span></th>
				<th><span>Bereich/Thema</span></th>
				<th><span>Provider</span></th>
				<th><span>Zugriffsmodus</span></th>
				<th><span></span></th>
			</tr>
			{% for vocab in vocabs %}
			<tr>
				<td><span>{{ vocab.name }}</span></td>
				<td><span>{{ vocab.version }}</span></td>
				<td><span>{{ vocab.domain }}</span></td>
				<td><span>{{ vocab.provider.name }}</span></td>
				<td><span>{{ vocab.access_level }}</span></td>
				<td><span><a class="button button-regular button-small" href="{% url 'TM:vocab_detail' vocab.id %}">Detailansicht&nbsp;&rarr;</a></span></td>
			</tr>
			{% endfor %}
		</table>
	</div>

	{% csrf_token %}
	<script type="application/javascript" src="{% static '3rdparty/ajv/6.5.2/ajv.min.js' %}"></script>
	<script type="application/javascript" src="{% static '3rdparty/x2js/1.2.0/xml2json.min.js' %}"></script>
	<script type="application/javascript" src="{% static 'TM/scripts/expandable_menu.js' %}"></script>
	<script type="application/javascript" src="{% static 'TM/scripts/json_xml_import.js' %}"></script>
	<script type="application/javascript" src="{% static 'TM/scripts/verticalTree.js' %}"></script>
	<script type="application/javascript">
		"use strict";

		var json_schema = JSON.parse("{{ json_schema|escapejs }}");

		$(function () {
			var $importSection = $('<div id="json_xml_import_section"/>')

			var $jsonXmlImportSection = createExpandableMenu($importSection, "Thesaurus aus Datei importieren");
			$("<a id='create_new_tree_with_json'>JSON-Datei importieren</a>")
				.on("click", function (event) {
					selectJSONFileAndValidate(saveAsNewTree);
					return false;
				})
				.appendTo($jsonXmlImportSection);

			$("<a id='create_new_tree_with_xml'>XML-Datei importieren</a>")
				.on("click", function (event) {
					selectXMLFileAndValidate(saveAsNewTree);
					return false;
				})
				.appendTo($jsonXmlImportSection);

			$("div#import_section").append($importSection);

			function saveAsNewTree(json) {
				var tree = traverseTreeAndReplaceID(json, true);
				// Create new thesaurus with json tree
				var urlForPostRequest = "{% url 'TM:vocab_create' %}";
				var jsonString = JSON.stringify(tree);
				var submitForm = $("<form method='post' action='" + urlForPostRequest + "'/>").hide().appendTo(document.body);
				$("input[name=csrfmiddlewaretoken]").appendTo(submitForm);
				$("<input/>")
					.attr("type", "hidden")
					.attr("name", "tree")
					.attr("value", jsonString)
					.appendTo(submitForm);
				submitForm.submit();
			}
		});
	</script>

{% endblock %}